; kred-x.scm liefert folgende Funktionen fr Fettdruck-Kreiseditoren
;
; (kred-init) => #f/#t
; (kred-draw-circle pointx pointy radius) => ...
; (kred-show-drawing) => ...
; (kred-get-next-event) => (type detail x y)

(require 'xlib)

(define dsply (open-display))
; Eine Abfrage nach dem Erfolg ist unntig, denn bei
; Problemen bricht open-display mit Fehlermeldung ab
; 'display geht nicht als Variablenname, denn dies ist schon eine
; Standardausgabefunktion, Umdefinition wird mit Chaos bestraft.
 
(define black (black-pixel dsply))
(define white (white-pixel dsply))

(define W 800) ; Fensterbreite
(define H 600) ; Fensterhhe

(define visible (create-window 
		 'parent (display-root-window dsply)
		 'width W 'height H 'background-pixel white 'event-mask 
		 '(exposure key-press button-press button-release)))

(define title '("kred"))
(set-wm-name!      visible title)
(set-wm-icon-name! visible title)

(map-window visible)

(define invisible (create-pixmap visible W H (display-default-depth dsply)))
; Hier wird das Bild berechnet, bevor es angeziegt wird.
; Habe noch keinen berblick, wie das mit Tiefe 1 und dann copy-plane 
; bitmap->colormap geht, zur Zeit also 420 KB verschwendet

(define gcdraw (create-gcontext 'window visible   'line-width 5
				'background white 'foreground black))

(define gclear (copy-gcontext gcdraw visible))
(set-gcontext-function! gclear 'clear) ; gclear ist der Kontext zum Radieren
(fill-rectangle invisible gclear 0 0 W H)

(define (kred-init) (display? dsply)) ;  bogus, knnte auch einfach #t liefern

(define 360-degrees (* 360 64)) ; Vollkreis
(define (kred-draw-circle x y r) 
  (let ((d (* 2 r)))
    (draw-arc invisible gcdraw (- x r) (- y r) d d 0 360-degrees)))

(define (kred-show-drawing)
  (copy-area invisible gcdraw 0 0 W H visible 0 0)
  (fill-rectangle invisible gclear 0 0 W H))

(define button (string-length "button")) ; 'button1 & 'button3 entziffern
(define (button-event . data)
  (list (car data)
	(- (char->integer (string-ref (symbol->string (list-ref data 10))
				      button))
	   (char->integer #\0))
	(list-ref data 5) (list-ref data 6)))

(define discard #t) (define nopeek #f)
(define (kred-get-next-event)
  (handle-events 
   dsply discard nopeek
   (expose (lambda data '(expose)))
   (key-press (lambda data 
		`(key-press ,(lookup-string dsply (list-ref data 10) '())))) 
   ((button-press button-release) button-event)))

(load 'kred.scm)
